﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace System.Events
{
    public class MessageBase : EventArgs
    {
        public MessageBase()
        {
        }
    }

    public class GenericMessage<T> : MessageBase
    {
        public T Content { get; protected set; }

        public GenericMessage()
            : this(default(T))
        {

        }
        public GenericMessage(T content) : base()
        {
            Content = content;
        }
    }
}
