﻿using System.Collections.Generic;
using System.Data.Services.Client;

namespace System.Threading.Tasks
{
    public static class AsyncExtensions
    {
        public static async Task<IEnumerable<T>> ExecuteAsync<T>(this DataServiceQuery<T> query)
        {
            return await Task.Factory.FromAsync<IEnumerable<T>>(query.BeginExecute(null, null), query.EndExecute);
        }
    }
}
