﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Windows.UI.Notifications;

namespace Windows.UI.Notifications
{
    public class BadgeNotificationData
    {
        public BadgeTemplateType Template {get; private set;}
        public string Value { get; private set; }
        public DateTimeOffset? ExpirationTime { get; private set; }

        public BadgeNotificationData(BadgeTemplateType template, string value, DateTimeOffset? expirationTime)
        {
            Template = template;
            Value = value;
            ExpirationTime = expirationTime;
        }
    }
}
